/**
 * @file usr_key.h
 * @brief L[{[h͊֘Å֐
 */
//---------------------------------------------------------------------------
#ifndef UsrKeyH
#define UsrKeyH

//---------------------------------------------------------------------------
#define ESC_INTERVAL	256

#define REPEAT_WAIT		50

extern UnicodeString KeyStr_Shift;
extern UnicodeString KeyStr_Ctrl;
extern UnicodeString KeyStr_Alt;
extern int KeyboardMode;

/**
 * @brief L[Xg̍쐬
 * @param[out] lst L[Xg
 */
void make_KeyList(TStringList *lst);

void assign_KeyList(TComboBox *cp, bool ins_empty = false, bool keep_item = false);

/**
 * @brief wL[Ă邩H
 * @param key zL[R[h
 */
bool is_KeyDown(WORD key);

/**
 * @brief _CAOL[H
 * @param Key zL[R[h
 */
bool is_DialogKey(WORD Key);

/**
 * @brief 0`9L[H
 * @param keystr L[
 */
bool is_Num0to9(UnicodeString keystr);

/**
 * @brief WPARAM VtgԂ擾
 * @param prm
 * @return int
 */
int  get_shift_from_wparam(WPARAM prm);

/**
 * @brief {L[{[hH
 */
bool is_JpKeybd();

/**
 * @brief L[E}EXobt@NA
 * @param key_only L[obt@̂݃NA
 */
void ClearKeyBuff(bool key_only = false);

/**
 * @brief Rg[ŃL[
 * @param cp ΏۃRg[
 * @param key zL[R[h
 */
void perform_Key(TControl *cp, int key);

/**
 * @brief Rg[ENTERL[
 * @param cp ΏۃRg[
 */
void perform_Key_RETURN(TControl *cp);

TShiftState   get_Shift();
UnicodeString get_ShiftStr(TShiftState Shift);
UnicodeString get_KeyStr(WORD Key);
UnicodeString get_KeyStr(WORD Key, TShiftState Shift);
UnicodeString get_AlNumChar(WORD Key);

UnicodeString WaitForKey();

//---------------------------------------------------------------------------
inline bool has_KeyDownMsg()
{
	MSG msg;
	return ::PeekMessage(&msg, NULL, WM_KEYDOWN, WM_KEYDOWN, PM_NOREMOVE);
}
//---------------------------------------------------------------------------
inline bool is_KeyPress_ESC()
{
	if (!Application->Active) return false;
	Application->ProcessMessages();		//Iv
	return (HIBYTE(::GetAsyncKeyState(VK_ESCAPE)) != 0);
}
//---------------------------------------------------------------------------
#endif
