/**
 * @file usr_file_ex.h
 * @brief t@Cp̔ėp֐
 */
//---------------------------------------------------------------------------
#ifndef UsrFileExH
#define UsrFileExH

//---------------------------------------------------------------------------
#include <winternl.h>

//---------------------------------------------------------------------------
/** pXtt@C̃}b`p^[*/
#define PATH_MATCH_PTN	"^(([a-z]:)|(%\\w+%)|(\\\\\\\\[^\\\\]+))\\\\(.+?\\\\)*.+$"

//---------------------------------------------------------------------------
#define	FileRenameInformation (FILE_INFORMATION_CLASS)10

typedef struct _FILE_RENAME_INFORMATION {
	BOOLEAN ReplaceIfExists;
	HANDLE	RootDirectory;
	ULONG	FileNameLength;
	WCHAR	FileName[1];
} FILE_RENAME_INFORMATION, *PFILE_RENAME_INFORMATION;

typedef LONG (WINAPI *FUNC_NtSetInformationFile)(HANDLE, PIO_STATUS_BLOCK, PVOID, ULONG, FILE_INFORMATION_CLASS);

//---------------------------------------------------------------------------
extern UnicodeString ExePath;	//!< NyanFi.exe ̏ꏊ

//---------------------------------------------------------------------------
int __fastcall FileComp_Base(TStringList *List, int Index1, int Index2);

/**
 * @brief 260ȏ̃pXɑΉ邽߂̃t@Cϊ
 * @details wt@CA260ȏ̃pXɑΉł`ɕϊ܂B
 * 󔒂̏ꍇȂǂɂΉł܂B
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString cv_ex_filename(UnicodeString fnam);

/**
 * @brief ϐ̕ϊ
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString cv_env_var(UnicodeString s);

/**
 * @brief ϐ܂ޕϊ
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString cv_env_str(UnicodeString s);

/**
 * @brief ϐ⏑܂ޕ񂩂ۂ̃pX擾
 * @param pnam Ώە
 * @return UnicodeString
 */
UnicodeString get_actual_path(UnicodeString pnam);

/**
 * @brief pXʂĂꍇApXt@CpXtɕϊ
 * @param fnam Ώۃt@C
 * @param sw_fmt WJ
 * @return UnicodeString
 */
UnicodeString get_actual_name(UnicodeString fnam, bool sw_fmt = false);

/**
 * @brief pXʂĂꍇAt@CpXƊgq菜
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString exclude_env_path(UnicodeString fnam);

/**
 * @brief st@C̃fBNg̑΃t@Cɕϊ
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString to_relative_name(UnicodeString fnam);

/**
 * @brief ΃pXɕϊ(hCu܂ޏꍇ͐K)
 * @param fnam Ώۃt@C
 * @param rnam fBNg(EmptyStr: ExePath)
 * @return UnicodeString
 */
UnicodeString to_absolute_name(UnicodeString fnam, UnicodeString rnam = EmptyStr);

/**
 * @brief փf[^Xg[lpX̎擾
 * @param fnam Ώۃt@C
 * @return UnicodeString pX
 */
UnicodeString extract_file_path(UnicodeString fnam);

/**
 * @brief t@CH
 * @param fnam1 t@C1
 * @param fnam2 t@C2
 * @param rnam fBNg(EmptyStr: ExePath)
 * @return true
 * @return false
 */
bool is_same_file(UnicodeString fnam1, UnicodeString fnam2, UnicodeString rnam = EmptyStr);

/**
 * @brief fBNgH (ϐΉ)
 * @param dir1 fBNg1
 * @param dir2 fBNg2
 * @return true
 * @return false
 */
bool is_same_dir(UnicodeString dir1, UnicodeString dir2);

/**
 * @brief pXXgɃ}b`邩H
 * @param dnam `FbNΏ
 * @param plist pXXg(ϐA%ExePath% Ή)
 * @param start_sw Ov(false:v)
 * @return true
 * @return false
 */
bool match_path_list(UnicodeString dnam, UnicodeString plist, bool start_sw = false);

/**
 * @brief [g(hCu܂UNC̃Rs[^)擾
 * @param pnam ΏۃpX
 * @return UnicodeString
 */
UnicodeString get_root_name(UnicodeString pnam);

/**
 * @brief ۂ̑召Ńt@C擾
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString get_case_name(UnicodeString fnam);

/**
 * @brief [gfBNgH
 * @param dnam ΏۃpX
 * @return true
 * @return false
 */
bool is_root_dir(UnicodeString dnam);

/**
 * @brief UNCpX̃[gH
 * @param dnam ΏۃpX
 * @return true
 * @return false
 */
bool is_root_unc(UnicodeString dnam);

/**
 * @brief fBNg[g̏ꍇA \ 菜
 * @param dnam ΏۃpX
 * @return UnicodeString
 */
UnicodeString exclede_delimiter_if_root(UnicodeString dnam);

/**
 * @brief hCu(啶A\t)擾
 * @param dnam ΏۃpX
 * @return UnicodeString
 */
UnicodeString get_drive_str(UnicodeString dnam);

/**
 * @brief LȃhCuH
 * @param drv hCu
 * @return true
 * @return false
 */
bool drive_exists(UnicodeString drv);

/**
 * @brief hCu̎ނ擾
 * @param dnam ΏۃpX
 * @return UINT
 */
UINT get_drive_type(UnicodeString dnam);

/**
 * @brief NX^TCY擾
 * @param dnam ΏۃpX
 * @return int
 */
int get_ClusterSize(UnicodeString dnam);

/**
 * @brief t@C̃x[X擾
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString get_base_name(UnicodeString fnam);

/**
 * @brief gq擾
 * @Note  O . Ŏn܂ꍇ(hbgt@C)A̒͊̕gqƂ݂Ȃ܂B
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString get_extension(UnicodeString fnam);

/**
 * @brief Ώۂt@CȂgq擾
 * @param fnam Ώۃt@C
 * @return UnicodeString
 */
UnicodeString get_extension_if_file(UnicodeString fnam);

UnicodeString nrm_FileExt(UnicodeString fext);

/**
 * @brief gq̃`FbN
 * @details ΏۊgqAw肵gqXgɊ܂܂Ă邩ׂ܂B@n
 * gqXǵA. ŋ؂ꂽgq̕тł(: ".txt.html.md")B
 * @param fext Ώۊgq
 * @param list gqXg
 * @return true ܂܂Ă
 * @return false ܂܂ĂȂ
 */
bool test_FileExt(UnicodeString fext, UnicodeString list);

/**
 * @brief gq̃`FbN(TCYw\)
 * @details ΏۊgqAw肵gqXgɊ܂܂Ă邩ׂ܂B@n
 * gqXǵA. ŋ؂ꂽgq̕тłB@n
 * gq̌ : ŋ؂ĐTCY(MBP)wł܂B̏ꍇAt@CTCYTCYƃ}b`܂B@n
 * : ".exe:100.dll"
 * @param fext Ώۊgq
 * @param list gqXg
 * @param size t@CTCY
 * @return true ܂܂Ă(TCYȏ)
 * @return false ܂܂ĂȂ
 */
bool test_FileExtSize(UnicodeString fext, UnicodeString list, __int64 size);

/**
 * @brief fBNg̖Ɂu\vt
 * @details ΏۃfBNg̖ɋ؂蕶u\vt܂BEmptyStr ̏ꍇ EmptyStr Ԃ܂B
 * @param dnam ΏۃfBNg
 * @return UnicodeString
 */
UnicodeString to_path_name(UnicodeString dnam);

/**
 * @brief fBNg(́u\v)擾
 * @param dnam ΏۃfBNg
 * @return UnicodeString
 */
UnicodeString get_dir_name(UnicodeString dnam);

/**
 * @brief efBNg擾
 * @param dnam ΏۃfBNg
 * @return UnicodeString 
 */
UnicodeString get_parent_path(UnicodeString dnam);

/**
 * @brief K؂FTPpXɕϊ
 * @param pnam 
 * @return UnicodeString 
 */
UnicodeString nrm_ftp_path(UnicodeString pnam);

/**
 * @brief ΏۃpX𕪉 TStringDynArray 쐬
 * @param pnam ΏۃpX
 * @param dlmt fBNg؂
 * @return TStringDynArray 
 */
TStringDynArray split_path(UnicodeString pnam, UnicodeString dlmt);

/**
 * @brief ΏۃpX𕪉 TStringDynArray 쐬
 * @param pnam ΏۃpX
 * @return TStringDynArray 
 */
TStringDynArray split_path(UnicodeString pnam);

/**
 * @brief "UNCpX:[U" 烆[U𕪗
 * @param dnam pX
 * @return UnicodeString
 */
UnicodeString split_user_name(UnicodeString &dnam);

/**
 * @brief Rs[^H
 * @param pnam ΏۃpX
 * @return true
 * @return false
 */
bool is_computer_name(UnicodeString pnam);

/**
 * @brief fBNgANZX\H
 * @param dnam ΏۃpX
 * @return true
 * @return false
 */
bool is_dir_accessible(UnicodeString dnam);

/**
 * @brief hCuANZX\H
 * @param dnam hCun܂pX
 * @return true
 * @return false
 */
bool is_drive_accessible(UnicodeString dnam);

/**
 * @brief hCuCgveNgĂ邩H
 * @param dnam hCun܂pX
 * @return true
 * @return false
 */
bool is_drive_protected(UnicodeString dnam);

/**
 * @brief NTFSk̐ݒ
 * @param fnam Ώۃt@C
 * @param sw k
 * @return true
 * @return false
 */
bool set_CompressAttr(UnicodeString fnam, bool sw);

/**
 * @brief t@C̑擾
 * @param fnam Ώۃt@C
 * @return int l(TSearchRec.Attr Ɠ)
 */
int  file_GetAttr(UnicodeString fnam);

/**
 * @brief t@C̑ݒ
 * @param fnam Ώۃt@C
 * @param attr l(TSearchRec.Attr Ɠ)
 * @return true 
 * @return false s
 */
bool file_SetAttr(UnicodeString fnam, int attr);

/**
 * @brief fBNg̑Rs[
 * @param src_nam Rs[fBNg
 * @param dst_nam Rs[fBNg
 * @param remove_ro Ǎp
 * @return true 
 * @return false s
 */
bool dir_CopyAttr(UnicodeString src_nam, UnicodeString dst_nam, bool remove_ro = false);

/**
 * @brief t@C̓ǂݏop
 * @param fnam Ώۃt@C
 * @return true 
 * @return false s
 */
bool set_FileWritable(UnicodeString fnam);

/**
 * @brief p[X|Cg?
 * @param fnam Ώۃt@C
 * @return true
 * @return false
 */
bool is_SymLink(UnicodeString fnam);

/**
 * @brief NJEg擾
 * @param fnam Ώۃt@C
 * @return int NJEg(2ȏȂn[hN)
 */
int  get_HardLinkCount(UnicodeString fnam);

/**
 * @brief t@C̓ꐫ`FbN
 * @param fnam1 Ώۃt@C1
 * @param fnam2 Ώۃt@C2
 * @return true
 * @return false
 */
bool is_IdenticalFile(UnicodeString fnam1, UnicodeString fnam2);

/**
 * @brief t@C̑݃`FbN
 * @param fnam Ώۃt@C
 * @return true ݂
 * @return false ݂Ȃ
 */
bool file_exists(UnicodeString fnam);

/**
 * @brief t@C̑݃`FbN
 * @details t@C݂̑`FbN܂BΏۂfBNgꍇ͐܂B
 * @param fnam Ώۃt@C
 * @return true t@CƂđ݂
 * @return false t@CƂđ݂Ȃ
 */
bool file_exists_x(UnicodeString fnam);

/**
 * @brief t@C̑݃`FbN
 * @details t@C݂̑`FbN܂Bt@C"O,CfbNX"Ƃ`ꍇA, ȍ~ă`FbN܂B
 * @param fnam Ώۃt@C
 * @return true
 * @return false
 */
bool file_exists_ico(UnicodeString fnam);

/**
 * @brief t@C(ChJ[h)̑݃`FbN
 * @details t@C(ChJ[h)̑݃`FbNs܂Bfnm ɂ́AŏɃ}b`t@CԂ܂B
 * @param[in,out] fnam t@C(ChJ[h)
 * @return true
 * @return false
 */
bool file_exists_wc(UnicodeString &fnam);

/**
 * @brief fBNg̑݃`FbN
 * @param dnam ΏۃfBNg
 * @return true
 * @return false
 */
bool dir_exists(UnicodeString dnam);

/**
 * @brief E莞[J TDateTime ɕϊ
 * @param utc E莞
 * @return TDateTime [J
 */
TDateTime utc_to_DateTime(FILETIME *utc);

/**
 * @brief t@C̃^CX^v TDateTime ^Ŏ擾
 * @param fnam Ώۃt@C
 * @return TDateTime ^CX^v(XV)
 */
TDateTime get_file_age(UnicodeString fnam);

/**
 * @brief t@CTCY擾
 * @param fnam t@C
 * @return __int64 TCY
 */
__int64 get_file_size(UnicodeString fnam);

/**
 * @brief kTCY擾
 * @param fnam t@C
 * @return __int64 kTCY
 */
__int64 get_comp_size(UnicodeString fnam);

/**
 * @brief փf[^Xg[tpXH
 * @param fnam t@C
 * @return true
 * @return false
 */
bool is_ADS_name(UnicodeString fnam);

/**
 * @brief փf[^Xg[̋؂ʒu擾
 * @param fnam t@C
 * @return int ؂̈ʒu
 */
int  pos_ADS_delimiter(UnicodeString fnam);

/**
 * @brief փf[^Xg[tpX𕪉
 * @details փf[^Xg[tpXAt@CƃXg[ɕ܂B
 * t@C߂lɂȂAXg[ fnam ɐݒ肳܂B
 * @param[in,out] fnam t@C
 * @return UnicodeString t@C
 */
UnicodeString split_ADS_name(UnicodeString &fnam);

/**
 * @brief փf[^Xg[̍폜
 * @param fnam t@C
 * @param force ǍpłIɕύX
 * @param mask }XN
 * @param[out] lst 폜Xg[̃Xg
 * @retval 1 
 * @retval 0 s(lst->Text ɃG[bZ[W)
 * @retval -1 ADSȂ
 */
int delete_ADS(UnicodeString fnam, bool force = false, UnicodeString mask = "*", TStringList *lst = NULL);

/**
 * @brief փf[^Xg[̕ύX
 * @param fnam t@C:Xg[
 * @param new_name :VXg[
 * @return true 
 * @return false s
 */
bool rename_ADS(UnicodeString fnam, UnicodeString new_name);

/**
 * @brief wfBNg݂Ȃꍇɍ쐬
 * @param dnam fBNg
 * @return UnicodeString fBNg(쐬łȂꍇ EmptyStr)
 */
UnicodeString chk_cre_dir(UnicodeString dnam);

/**
 * @brief fBNgH
 * @param dnam ΏۃfBNg
 * @param no_file t@C܂܂ĂȂ
 * @return true
 * @return false
 */
bool is_EmptyDir(UnicodeString dnam, bool no_file = false);

/**
 * @brief p\ȃhCũXg擾
 * @param[out] lst hCũXg(hCu:\)
 * @return int
 */
int get_available_drive_list(TStringList *lst);

/**
 * @brief t@C̑擾
 * @param atr l
 * @return UnicodeString (RHSAC ܂܂Ȃ _)
 */
UnicodeString get_file_attr_str(int atr);

/**
 * @brief wfBNgŃ}XNɊYŏ̃t@C擾
 * @param pnam ΏۃfBNg
 * @param mask }XN
 * @param subSW TufBNg`FbN
 * @return UnicodeString t@C
 */
UnicodeString find_FirstFile(UnicodeString pnam, UnicodeString mask, bool subSW = false);

/**
 * @brief wfBNg̃}XNɊYSt@C擾
 * @param pnam ΏۃfBNg
 * @param mask }XN
 * @param[out] lst t@CXg
 * @param subSW TufBNg
 */
void get_files(UnicodeString pnam, UnicodeString mask, TStrings *lst, bool subSW = false);

/**
 * @brief wfBNg̃}XNɊYSt@C̃Xgǉ擾
 * @param pnam ΏۃfBNg
 * @param mask }XN
 * @param[out] lst t@CXg
 * @param subSW TufBNg
 * @param subn TufBNg̊Kw̐[
 * @param skip_dir ODir}XN(;ŋ؂蕡)
 * @param inc_hide B
 * @param inc_sys VXe
 * @return int t@C(fBNg͏)
 */
int  get_all_files_ex(UnicodeString pnam, UnicodeString mask, TStrings *lst,
	bool sub_sw = false, int sub_n = 99, UnicodeString skip_dir = EmptyStr,
	bool inc_hide = true, bool inc_sys = true);

/**
 * @brief wfBNg̑SfBNg擾
 * @param pnam ΏۃfBNg
 * @param[out] lst fBNgXg
 * @param subSW TufBNg
 */
void get_dirs(UnicodeString pnam, TStrings *lst, bool subSW = true);

/**
 * @brief wt@CɃ^CX^v(XV)ݒ
 * @param fnam Ώۃt@C
 * @param dt ^CX^v(XV)
 * @param force ǍpłIɕύX
 * @return true 
 * @return false s
 */
bool set_file_age(UnicodeString fnam, TDateTime dt, bool force = false);

/**
 * @brief ̃t@C쐬
 * @param fnam 쐬t@C
 * @return true 
 * @return false s
 */
bool create_EmptyFile(UnicodeString fnam);

/**
 * @brief fBNg̍쐬
 * @param dnam 쐬fBNg
 * @return true 
 * @return false s
 */
bool create_Dir(UnicodeString dnam);

/**
 * @brief fBNg̍쐬(Kw)
 * @param dnam 쐬fBNg
 * @return true 
 * @return false s
 */
bool create_ForceDirs(UnicodeString dnam);

/**
 * @brief fBNg̍폜
 * @param dnam 폜fBNg
 * @param force Iɍ폜
 * @return true 
 * @return false s
 */
bool delete_Dir(UnicodeString dnam, bool force = false);

/**
 * @brief TufBNg܂߂fBNg̍폜
 * @param pnam 폜fBNg
 * @return true 
 * @return false s
 */
bool delete_Dirs(UnicodeString pnam);

/**
 * @brief t@C̈ړ
 * @param old_nam ړt@C
 * @param new_nam ړt@C
 * @return true 
 * @return false s
 */
bool move_File(UnicodeString old_nam, UnicodeString new_nam);

/**
 * @brief t@C̃Rs[
 * @param src_nam Rs[t@C
 * @param dst_nam Rs[t@C
 * @return true 
 * @return false s
 */
bool copy_File(UnicodeString src_nam, UnicodeString dst_nam);

/**
 * @brief t@CO̕ύX
 * @param old_nam ̃t@C
 * @param new_nam ύX̃t@C
 * @return true 
 * @return false s
 */
bool rename_File(UnicodeString old_nam, UnicodeString new_nam);

/**
 * @brief pX̕ύX
 * @param old_nam ̃pX
 * @param new_nam ύX̃pX
 * @return true 
 * @return false s
 */
bool rename_Path(UnicodeString old_nam, UnicodeString new_nam);

//---------------------------------------------------------------------------
#ifndef REPARSE_DATA_BUFFER
typedef struct _REPARSE_DATA_BUFFER {
	ULONG  ReparseTag;
	USHORT ReparseDataLength;
	USHORT Reserved;

	union {
		struct {
		  USHORT SubstituteNameOffset;
		  USHORT SubstituteNameLength;
		  USHORT PrintNameOffset;
		  USHORT PrintNameLength;
		  ULONG  Flags;
		  WCHAR  PathBuffer[1];
		} SymbolicLinkReparseBuffer;

		struct {
		  USHORT SubstituteNameOffset;
		  USHORT SubstituteNameLength;
		  USHORT PrintNameOffset;
		  USHORT PrintNameLength;
		  WCHAR  PathBuffer[1];
		} MountPointReparseBuffer;

		struct {
		  UCHAR DataBuffer[1];
		} GenericReparseBuffer;
	};
} REPARSE_DATA_BUFFER, *PREPARSE_DATA_BUFFER;
#endif

//---------------------------------------------------------------------------
/**
 * @brief WNV̍쐬
 * @param pnam
 * @param target
 * @return true 
 * @return false s
 */
bool cre_Junction(UnicodeString pnam, UnicodeString target);

//---------------------------------------------------------------------------
BYTE   fsRead_byte(TFileStream *fs);
int    fsRead_int2(TFileStream *fs, bool be_sw = false);
int    fsRead_int3(TFileStream *fs, bool be_sw = false);
int    fsRead_int4(TFileStream *fs, bool be_sw = false);
double fsRead_double(TFileStream *fs);
UnicodeString fsRead_char(TFileStream *fs, int size);
UnicodeString fsRead_comment_utf8(TFileStream *fs);

/**
 * @brief t@Č݈ʒuɎw蕶񂪂邩H@n
          ΒʒuցAΌ݈ʒû܂
 * @param fs t@CXg[
 * @param s 
 * @return true
 * @return false
 */
bool fsRead_check_char(TFileStream *fs, const char *s);

//---------------------------------------------------------------------------
inline UnicodeString warn_filename_RLO(UnicodeString fnam)
{
	return ReplaceStr(ExtractFileName(fnam), L"\u202e", "<RLO>");
}
//---------------------------------------------------------------------------
inline UnicodeString warn_pathname_RLO(UnicodeString pnam)
{
	return ReplaceStr(pnam, L"\u202e", "<RLO>");
}
//---------------------------------------------------------------------------
#endif
